#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin >> n;
    int O, A, B, AB;
    cin >> O >> A >> B >> AB;
    int potrebe[n];
    string grupa[n];
    int resenje[4][n];
    for (int i = 0; i < n; i++)
    {
        resenje[0][i]=0;
        resenje[1][i]=0;
        resenje[2][i]=0;
        resenje[3][i]=0;
    }
    
    for (int i = 0; i < n; i++) //nulta ,A i B
    {
        cin >> grupa[i];
        cin >> potrebe[i];
        if (grupa[i] == "O")
        {
            if (O >= potrebe[i])
            {
                O -= potrebe[i];
                resenje[0][i] = potrebe[i];
            }
            else
            {
                cout << "nemoguce";
                return 0;
            }
        }
        else if (grupa[i] == "A")
        {
            if (A >= potrebe[i])
            {
                A -= potrebe[i];
                resenje[1][i] = potrebe[i];
            }
            else
            {
                potrebe[i] -= A;
                resenje[1][i] = A;
                A = 0;
                if (O >= potrebe[i])
                {
                    O -= potrebe[i];
                    resenje[0][i] = potrebe[i];
                }
                else
                {
                    cout << "nemoguce";
                    return 0;
                }
            }
        }
        else if (grupa[i] == "B")
        {
            if (B >= potrebe[i])
            {
                B -= potrebe[i];
                resenje[2][i] = potrebe[i];
            }
            else
            {
                potrebe[i] -= B;
                resenje[2][i] = B;
                B = 0;
                if (O >= potrebe[i])
                {
                    O -= potrebe[i];
                    resenje[0][i] = potrebe[i];
                }
                else
                {
                    cout << "nemoguce";
                    return 0;
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (grupa[i] == "AB")
        {
            if (AB >= potrebe[i])
            {
                AB -= potrebe[i];
                resenje[3][i] = potrebe[i];
                potrebe[i] = 0;
            }
            else
            {
                potrebe[i] -= AB;
                resenje[3][i] = AB;
                AB = 0;
                if (A >= potrebe[i])
                {
                    A -= potrebe[i];
                    resenje[1][i] = potrebe[i];
                }
                else
                {
                    potrebe[i] -= A;
                    resenje[1][i] = A;
                    A = 0;
                    if (B >= potrebe[i])
                    {
                        B -= potrebe[i];
                        resenje[2][i] = potrebe[i];
                    }
                    else
                    {
                        potrebe[i] -= B;
                        resenje[2][i] = B;
                        B = 0;
                        if (O >= potrebe[i])
                        {
                            O -= potrebe[i];
                            resenje[0][i] = potrebe[i];
                        }
                        else
                        {
                            cout << "nemoguce";
                            return 0;
                        }
                    }
                }
            }
        }
    }
    cout<<"moguce"<<endl;
    for (int i = 0; i < n; i++)
    {
        cout<<resenje[0][i]<<" "<<resenje[1][i]<<" "<<resenje[2][i]<<" "<<resenje[3][i]<<endl;
    }
    
}